<template>
  <span class="flex justify-start">
    <span class="flex justify-center items-center leading-3 mr-2">{{ rating }}</span>
    <div class="flex flex-row">
      <IconCSS
        v-for="star in stars"
        :key="star.id"
        :name="star.icon"
        :class="star.color"
        star="star"
      />
    </div>
  </span>
</template>

<script setup lang="ts">
import { ref, onMounted } from 'vue'

const { rating } = defineProps(['rating'])
type Star = {
  id: number
  icon: string
  color: string
}
const stars = ref<Array<Star>>([
  { id: 1, icon: 'mdi:star', color: 'text-slate-400' },
  { id: 2, icon: 'mdi:star', color: 'text-slate-400' },
  { id: 3, icon: 'mdi:star', color: 'text-slate-400' },
  { id: 4, icon: 'mdi:star', color: 'text-slate-400' },
  { id: 5, icon: 'mdi:star', color: 'text-slate-400' },
])

const isNumeric = (value: number) => {
  return value % 1 === 0
}

const setFullStar = () => {
  for (let index = 0; index < Math.floor(rating); index++) {
    const element = stars.value[index]
    element.color = 'text-orange-400'
  }
}

const setHalfStar = () => {
  if (!isNumeric(rating)) {
    stars.value[Math.floor(rating)].icon = 'mdi:star-half-full'
  }
}

onMounted(() => {
  // Set Full Star
  new Promise(resolve => {
    resolve(setFullStar())
  })
  .then(() => setHalfStar())
})
</script>

<style scoped>
svg.icon path {
  /* background-color: red; */
  color: green;
  fill: red;
}
</style>